## coq-elpi 1.11.2

=== Makefile ===

# detection of coq
ifeq "$(COQBIN)" ""
COQBIN := $(shell which coqc >/dev/null 2>&1 && dirname `which coqc`)
endif
ifeq "$(COQBIN)" ""
$(error Coq not found, make sure it is installed in your PATH or set COQBIN)
else
$(info Using coq found in $(COQBIN), from COQBIN or PATH)
endif
export COQBIN := $(COQBIN)/

# detection of elpi
ifeq "$(ELPIDIR)" ""
ELPIDIR=$(shell ocamlfind query elpi 2>/dev/null)
endif
ifeq "$(ELPIDIR)" ""
$(error Elpi not found, make sure it is installed in your PATH or set ELPIDIR)
endif
export ELPIDIR

DEPS=$(ELPIDIR)/elpi.cmxa $(ELPIDIR)/elpi.cma

APPS=$(addprefix apps/, derive eltac NES)

ifeq "$(COQ_ELPI_ALREADY_INSTALLED)" ""
DOCDEP=build
else
DOCDEP=
endif

DOCDIR=$(shell $(COQBIN)/coqc -where)/../../share/doc/coq-elpi/

all: build test

build: Makefile.coq $(DEPS)
	@echo "########################## building plugin ##########################"
	@if [ -x $(COQBIN)/coqtop.byte ]; then \
		$(MAKE) --no-print-directory -f Makefile.coq bytefiles; \
	fi
	@$(MAKE) --no-print-directory -f Makefile.coq opt
	@echo "########################## building APPS ############################"
	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true

test: Makefile.test.coq $(DEPS) build
	@echo "########################## testing plugin ##########################"
	@$(MAKE) --no-print-directory -f Makefile.test.coq
	@echo "########################## testing APPS ############################"
	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true

doc: $(DOCDEP)
	@echo "########################## generating doc ##########################"
	@mkdir -p doc
	@$(foreach tut,$(wildcard examples/tutorial*$(ONLY)*.v),\
		echo ALECTRYON $(tut) && ./etc/alectryon_elpi.py \
		    --frontend coq+rst \
			--output-directory doc \
		    --pygments-style vs \
			-R theories elpi -Q src elpi \
			$(tut) &&) true
	@cp stlc.html doc/

.merlin: force
	@rm -f .merlin
	@$(MAKE) --no-print-directory -f Makefile.coq $@

.PHONY: force build all test doc

Makefile.coq Makefile.coq.conf:  src/coq_elpi_config.ml _CoqProject
	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
Makefile.test.coq Makefile.test.coq.conf: _CoqProject
	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq

src/coq_elpi_config.ml:
	echo "let elpi_dir = \"$(abspath $(ELPIDIR))\";;" > $@

clean:
	@$(MAKE) -f Makefile.coq $@
	@$(MAKE) -f Makefile.test.coq $@
	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true

include Makefile.coq.conf
V_FILES_TO_INSTALL := \
  $(filter-out theories/wip/%.v,\
  $(COQMF_VFILES))

install:
	@echo "########################## installing plugin ############################"
	@$(MAKE) -f Makefile.coq $@ VFILES="$(V_FILES_TO_INSTALL)"
	@if [ -x $(COQBIN)/coqtop.byte ]; then \
		$(MAKE) -f Makefile.coq $@-byte VFILES="$(V_FILES_TO_INSTALL)"; \
	fi
	-cp etc/coq-elpi.lang $(COQMF_COQLIB)/ide/
	@echo "########################## installing APPS ############################"
	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true
	@echo "########################## installing doc ############################"
	-mkdir -p $(DOCDIR)
	-cp doc/* $(DOCDIR)


# compile just one file
theories/%.vo: force
	@$(MAKE) --no-print-directory -f Makefile.coq $@
tests/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@
examples/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@

SPACE=$(XXX) $(YYY)
apps/%.vo: force
	@$(MAKE) -C apps/$(word 1,$(subst /, ,$*)) \
		$(subst $(SPACE),/,$(wordlist 2,99,$(subst /, ,$*))).vo

=== debian/changelog ===
coq-elpi (1.11.2-2) unstable; urgency=medium

  * Fix -dev package not depending on the lib package. (Closes: #1002930)

 -- Julien Puydt <jpuydt@debian.org>  Mon, 17 Jan 2022 08:46:21 +0100

coq-elpi (1.11.2-1) unstable; urgency=medium

  * Initial release. (Closes: #999483)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 03 Dec 2021 09:02:11 +0100

=== debian/control ===
Source: coq-elpi
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-ocaml, coq, libcoq-ocaml-dev,
               libelpi-ocaml-dev
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
Homepage: https://github.com/LPCIC/coq-elpi

Package: libcoq-elpi-ocaml
Architecture: any
Depends: ${misc:Depends}, libcoq-ocaml, coq-${F:CoqABI}
Provides: ${ocaml:Provides}
Description: Coq plugin embedding Elpi (runtime)
 This package makes it possible to define new commands and tactics
 for Coq in Elpi.
 .
 Elpi implements a lambda-Prolog interpreter enriched with
 constraint handling rules.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides runtime libraries for the elpi plugin.

Package: libcoq-elpi-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, libcoq-elpi-ocaml
Provides: ${ocaml:Provides}
Description: Coq plugin embedding Elpi (devel)
 This package makes it possible to define new commands and tactics
 for Coq in Elpi.
 .
 Elpi implements a lambda-Prolog interpreter enriched with
 constraint handling rules.
 .
 Coq is a proof assistant for higher-order logic.
 .
 This package provides libraries needed to develop
 for the elpi plugin.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin
export ELPIDIR := $(OCAML_STDLIB_DIR)/elpi

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) build

override_dh_auto_install:
	dh_auto_install
	cp src/elpi_plugin.a debian/tmp/usr/lib/coq/user-contrib/elpi/
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(cma|cmxs|v|vo|vos|glob)$$' \
	  >> debian/libcoq-elpi-ocaml.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libcoq-elpi-ocaml-dev.install

override_dh_auto_clean:
	@echo "Clean target is fragile"

override_dh_gencontrol:
	dh_gencontrol -- -VF:CoqABI="$(COQ_ABI)"

override_dh_ocaml:
	dh_ocaml --nodefined-map=libcoq-elpi-ocaml-dev:Extfun,Gramext,Versdep,Fstream,Pretty,Token,Grammar,Ploc,Plexing,Plexer,Eprinter,Diff,Stdpp,Pprintf,Extfold,Elpi__Ptmap,Elpi__Util,Elpi__Builtin,Elpi__Data,Elpi__Ast,Elpi__Builtin_map,Elpi__Builtin,Elpi__Builtin_checker,Elpi__Builtin_stdlib,Elpi__API,Elpi__Runtime,Trace_ppx_runtime__Runtime,Elpi__Runtime_trace_on,Elpi__parser,Trace_ppx_runtime,Elpi__exported,Elpi,Elpi__Runtime_trace_off,Elpi__Builtin_set,Elpi__exported,Elpi__Parser,Elpi__Compiler,Elpi__,Ppx_deriving_runtime,Re__,Re__Fmt,Re__Category,Re__Group,Re__str,Re__Pcre,Re,Re__Str,Re__str,Re__Posix,Re__Automata,Re__Emacs,Re__Core,Re__Cset,Re__Color,Re__Perl,Re__Color_map,Re__Glob,Re_str,Re__Pmark,Result

## coq-elpi 1.12.0

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 DEPS=$(ELPIDIR)/elpi.cmxa $(ELPIDIR)/elpi.cma
 
-APPS=$(addprefix apps/, derive eltac NES)
+APPS=$(addprefix apps/, derive eltac NES locker)
 
 ifeq "$(COQ_ELPI_ALREADY_INSTALLED)" ""
 DOCDEP=build
@@ -66,11 +66,16 @@
 
 .PHONY: force build all test doc
 
-Makefile.coq Makefile.coq.conf:  src/coq_elpi_config.ml _CoqProject
+Makefile.coq Makefile.coq.conf: src/coq_elpi_builtins_HOAS.ml src/coq_elpi_config.ml _CoqProject
 	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
 	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
 Makefile.test.coq Makefile.test.coq.conf: _CoqProject
 	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq
+src/coq_elpi_builtins_HOAS.ml: elpi/coq-HOAS.elpi Makefile.coq.local
+	echo "(* Automatically generated from $<, don't edit *)" > $@
+	echo "let code = {|" >> $@
+	cat $< >> $@
+	echo "|}" >> $@
 
 src/coq_elpi_config.ml:
 	echo "let elpi_dir = \"$(abspath $(ELPIDIR))\";;" > $@
@@ -95,8 +100,9 @@
 	@echo "########################## installing APPS ############################"
 	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true
 	@echo "########################## installing doc ############################"
-	-mkdir -p $(DOCDIR)
-	-cp doc/* $(DOCDIR)
+	-mkdir -p $(DESTDIR)$(DOCDIR)
+	-cp doc/* $(DESTDIR)$(DOCDIR)
+	@echo "########################## installed ############################"
 
 
 # compile just one file

=== debian/changelog ===
coq-elpi (1.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 17 Jan 2022 15:44:00 +0100

## coq-elpi 1.12.1

=== debian/changelog ===
coq-elpi (1.12.1-2) unstable; urgency=medium

  * Adapt to the new coq library layout.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 06 Feb 2022 12:56:20 +0100

coq-elpi (1.12.1-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 21 Jan 2022 16:09:07 +0100

## coq-elpi 1.13.0

=== apps/NES/Makefile ===
# detection of coq
ifeq "$(COQBIN)" ""
COQBIN := $(shell which coqc >/dev/null 2>&1 && dirname `which coqc`)
endif
ifeq "$(COQBIN)" ""
$(error Coq not found, make sure it is installed in your PATH or set COQBIN)
else
$(info Using coq found in $(COQBIN), from COQBIN or PATH)
endif
export COQBIN := $(COQBIN)/

all: build test

build: Makefile.coq
	@$(MAKE) --no-print-directory -f Makefile.coq

test: Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq

theories/%.vo: force
	@$(MAKE) --no-print-directory -f Makefile.coq $@
tests/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@
examples/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@

Makefile.coq Makefile.coq.conf: _CoqProject
	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
Makefile.test.coq Makefile.test.coq.conf: _CoqProject.test
	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq

clean:
	@$(MAKE) -f Makefile.coq $@
	@$(MAKE) -f Makefile.test.coq $@

.PHONY: force all build test

install:
	@$(MAKE) -f Makefile.coq $@

=== debian/changelog ===
coq-elpi (1.13.0-7build2) kinetic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 14 May 2022 18:35:24 +0200

coq-elpi (1.13.0-7build1) kinetic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 May 2022 08:16:38 +0200

coq-elpi (1.13.0-7) unstable; urgency=medium

  * Made libcoq-elpi Architecture: all.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 17 Apr 2022 13:48:42 +0200

coq-elpi (1.13.0-6) unstable; urgency=medium

  * Add depends on the Coq ABI to all binary packages.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 16 Apr 2022 08:32:16 +0200

coq-elpi (1.13.0-5) unstable; urgency=medium

  * Fix binary packages' depends.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 13 Apr 2022 09:01:51 +0200

coq-elpi (1.13.0-4) unstable; urgency=medium

  * Re-upload source-only for testing migration.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 11 Apr 2022 09:12:49 +0200

coq-elpi (1.13.0-3) unstable; urgency=medium

  * Split the package, giving one more binary.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 01 Apr 2022 15:30:44 +0200

coq-elpi (1.13.0-2) unstable; urgency=medium

  * Update dates in d/copyright.
  * Add an upstream metadata file.
  * Add a lintian override for libcoq-elpi-ocaml-dev.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 23 Mar 2022 22:15:06 +0100

coq-elpi (1.13.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 10 Feb 2022 13:30:32 +0100

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,31 @@
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               dh-ocaml, coq, libcoq-ocaml-dev,
+               dh-ocaml, coq, libcoq-ocaml-dev (>= 8.15),
                libelpi-ocaml-dev
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
 Homepage: https://github.com/LPCIC/coq-elpi
 
+Package: libcoq-elpi
+Architecture: any
+Depends: ${misc:Depends}, libcoq-elpi-ocaml (>= ${source:Version}), coq-${F:CoqABI}
+Description: Coq plugin embedding Elpi (theories)
+ This package makes it possible to define new commands and tactics
+ for Coq in Elpi.
+ .
+ Elpi implements a lambda-Prolog interpreter enriched with
+ constraint handling rules.
+ .
+ Coq is a proof assistant for higher-order logic.
+ .
+ This package provides the Coq elpi plugin.
+
 Package: libcoq-elpi-ocaml
 Architecture: any
-Depends: ${misc:Depends}, libcoq-ocaml, coq-${F:CoqABI}
+Depends: ${misc:Depends}, ${ocaml:Depends}, coq-${F:CoqABI}
 Provides: ${ocaml:Provides}
+Recommends: libcoq-elpi
 Description: Coq plugin embedding Elpi (runtime)
  This package makes it possible to define new commands and tactics
  for Coq in Elpi.
@@ -29,7 +44,7 @@
 
 Package: libcoq-elpi-ocaml-dev
 Architecture: any
-Depends: ${misc:Depends}, libcoq-elpi-ocaml
+Depends: ${misc:Depends}, ${ocaml:Depends}, coq-${F:CoqABI}
 Provides: ${ocaml:Provides}
 Description: Coq plugin embedding Elpi (devel)
  This package makes it possible to define new commands and tactics

=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,10 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	cp src/elpi_plugin.a debian/tmp/usr/lib/coq/user-contrib/elpi/
+	cp src/elpi_plugin.a debian/tmp/usr/lib/ocaml/coq/user-contrib/elpi/
 	find debian/tmp -regextype posix-awk \
-	  -regex '.*\.(cma|cmxs|v|vo|vos|glob)$$' \
-	  >> debian/libcoq-elpi-ocaml.install
+	  -regex '.*\.(v|vo|vos|glob)$$' \
+	  >> debian/libcoq-elpi.install
 	find debian/tmp -regextype posix-awk \
 	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
 	  >> debian/libcoq-elpi-ocaml-dev.install

## coq-elpi 1.14.0

=== debian/changelog ===
coq-elpi (1.14.0-5build1) kinetic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 21 Jul 2022 18:05:00 +0200

coq-elpi (1.14.0-5) unstable; urgency=medium

  * Fix the deps which make the packages uninstallable.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 12 Jun 2022 20:11:07 +0200

coq-elpi (1.14.0-4) unstable; urgency=medium

  * Use dh-coq.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 12 Jun 2022 13:57:38 +0200

coq-elpi (1.14.0-3) unstable; urgency=medium

  * Re-upload because of broken ABI.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 01 Jun 2022 15:13:31 +0200

coq-elpi (1.14.0-2) unstable; urgency=medium

  * Re-upload because of broken ABI.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 21 May 2022 19:43:46 +0200

coq-elpi (1.14.0-1) unstable; urgency=medium

  * Tighten the deps between the binary packages.
  * Bump standards-version to 4.6.1.
  * New upstream release.
  * Adapt the workaround for re-exported symbols in d/rules.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 14 May 2022 15:37:01 +0200

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,19 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
-               dh-ocaml, coq, libcoq-ocaml-dev (>= 8.15),
-               libelpi-ocaml-dev
+               dh-ocaml, dh-coq, coq, libcoq-ocaml-dev (>= 8.15),
+               libcoq-stdlib, libelpi-ocaml-dev
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
 Homepage: https://github.com/LPCIC/coq-elpi
 
 Package: libcoq-elpi
 Architecture: any
-Depends: ${misc:Depends}, libcoq-elpi-ocaml (>= ${source:Version}), coq-${F:CoqABI}
+Depends: ${misc:Depends}, libcoq-elpi-ocaml (= ${binary:Version}), ${coq:Depends}
+Provides: ${coq:Provides}
 Description: Coq plugin embedding Elpi (theories)
  This package makes it possible to define new commands and tactics
  for Coq in Elpi.
@@ -28,7 +29,7 @@
 
 Package: libcoq-elpi-ocaml
 Architecture: any
-Depends: ${misc:Depends}, ${ocaml:Depends}, coq-${F:CoqABI}
+Depends: ${misc:Depends}, ${ocaml:Depends}
 Provides: ${ocaml:Provides}
 Recommends: libcoq-elpi
 Description: Coq plugin embedding Elpi (runtime)
@@ -44,7 +45,7 @@
 
 Package: libcoq-elpi-ocaml-dev
 Architecture: any
-Depends: ${misc:Depends}, ${ocaml:Depends}, coq-${F:CoqABI}
+Depends: ${misc:Depends}, ${ocaml:Depends}, libcoq-elpi-ocaml (= ${binary:Version})
 Provides: ${ocaml:Provides}
 Description: Coq plugin embedding Elpi (devel)
  This package makes it possible to define new commands and tactics

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin
export ELPIDIR := $(OCAML_STDLIB_DIR)/elpi

%:
	dh $@ --with ocaml,coq

override_dh_auto_build:
	$(MAKE) build

override_dh_auto_install:
	dh_auto_install
	cp src/elpi_plugin.a debian/tmp/usr/lib/ocaml/coq/user-contrib/elpi/
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(v|vo|vos|glob)$$' \
	  >> debian/libcoq-elpi.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o)$$' \
	  >> debian/libcoq-elpi-ocaml-dev.install

override_dh_auto_clean:
	@echo "Clean target is fragile"

override_dh_ocaml:
	dh_ocaml --nodefined-map=libcoq-elpi-ocaml-dev:Elpi_parser,Elpi_util,Elpi_parser__Ast,Elpi__Runtime,Elpi__,Elpi_util__Util,Elpi__Builtin_checker,Elpi__Builtin,Elpi__Ptmap,Elpi_parser__Grammar,Elpi__Data,Elpi_lexer_config,Elpi__API,Elpi_parser__Parse,Elpi__Builtin_set,Trace_ppx_runtime,Elpi_parser__Parser_config,Elpi_parser__Error_messages,Elpi_parser__Lexer,Elpi,Elpi_exer_config__Tokens,Elpi_Builtin_stdlib,Elpi__Legacy_parser_proxy,Elpi__Builtin_map,Elpi_lexer_config__Tokens,Elpi__Compiler,Trace_ppx_runtime__Runtime,Elpi_lexer_config__Lexer_config,Elpi__Builtin_stdlib,Elpi__Runtime_trace_off,MenhirLib,Ppx_deriving_runtime,Re__Perl,Re__Core,Re__Pcre,Re_str,Re__Automata,Re__Emacs,Re,Re__Fmt,Re__Group,Re__,Re__Glob,Re__Pmark,Re__Category,Re__Str,Re__Posix,Re__Color_map,Re__Cset,Result

## coq-elpi 1.15.6

=== Makefile ===
--- 
+++ 
@@ -29,24 +29,48 @@
 DOCDEP=
 endif
 
-DOCDIR=$(shell $(COQBIN)/coqc -where)/../../share/doc/coq-elpi/
+ifndef DOCDIR
+DOCDIR=$(shell $(COQBIN)/coqc -where)/../../share/doc/coq-elpi
+endif
 
-all: build test
+ifndef COQDOCINSTALL
+COQDOCINSTALL=$(DESTDIR)$(DOCDIR)
+endif
 
-build: Makefile.coq $(DEPS)
+
+all:
+	$(MAKE) build-core
+	$(MAKE) test-core
+	$(MAKE) examples
+	$(MAKE) build-apps
+	$(MAKE) test-apps
+
+build-core: Makefile.coq $(DEPS)
 	@echo "########################## building plugin ##########################"
 	@if [ -x $(COQBIN)/coqtop.byte ]; then \
 		$(MAKE) --no-print-directory -f Makefile.coq bytefiles; \
 	fi
 	@$(MAKE) --no-print-directory -f Makefile.coq opt
+
+build-apps: build-core
 	@echo "########################## building APPS ############################"
-	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true
+	@$(foreach app,$(APPS),$(MAKE) -C $(app) build &&) true
 
-test: Makefile.test.coq $(DEPS) build
+build: build-core build-apps
+
+test-core: Makefile.test.coq $(DEPS) build-core
 	@echo "########################## testing plugin ##########################"
 	@$(MAKE) --no-print-directory -f Makefile.test.coq
+
+test-apps: build-apps
 	@echo "########################## testing APPS ############################"
-	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true
+	@$(foreach app,$(APPS),$(MAKE) -C $(app) test &&) true
+
+test: test-core test-apps
+
+examples: Makefile.examples.coq $(DEPS) build-core
+	@echo "############################ examples ############################"
+	@$(MAKE) --no-print-directory -f Makefile.examples.coq
 
 doc: $(DOCDEP)
 	@echo "########################## generating doc ##########################"
@@ -69,8 +93,10 @@
 Makefile.coq Makefile.coq.conf: src/coq_elpi_builtins_HOAS.ml src/coq_elpi_config.ml _CoqProject
 	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
 	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
-Makefile.test.coq Makefile.test.coq.conf: _CoqProject
+Makefile.test.coq Makefile.test.coq.conf: _CoqProject.test
 	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq
+Makefile.examples.coq Makefile.examples.coq.conf: _CoqProject.examples
+	@$(COQBIN)/coq_makefile -f _CoqProject.examples -o Makefile.examples.coq
 src/coq_elpi_builtins_HOAS.ml: elpi/coq-HOAS.elpi Makefile.coq.local
 	echo "(* Automatically generated from $<, don't edit *)" > $@
 	echo "let code = {|" >> $@
@@ -100,17 +126,17 @@
 	@echo "########################## installing APPS ############################"
 	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true
 	@echo "########################## installing doc ############################"
-	-mkdir -p $(DESTDIR)$(DOCDIR)
-	-cp doc/* $(DESTDIR)$(DOCDIR)
+	-mkdir -p $(COQDOCINSTALL)
+	-cp doc/* $(COQDOCINSTALL)
 	@echo "########################## installed ############################"
 
 
 # compile just one file
 theories/%.vo: force
 	@$(MAKE) --no-print-directory -f Makefile.coq $@
-tests/%.vo: force build Makefile.test.coq
+tests/%.vo: force build-core Makefile.test.coq
 	@$(MAKE) --no-print-directory -f Makefile.test.coq $@
-examples/%.vo: force build Makefile.test.coq
+examples/%.vo: force build-core Makefile.test.coq
 	@$(MAKE) --no-print-directory -f Makefile.test.coq $@
 
 SPACE=$(XXX) $(YYY)

=== debian/changelog ===
coq-elpi (1.15.6-2) unstable; urgency=medium

  * Rebuild because of new elpi.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 25 Oct 2022 21:25:22 +0200

coq-elpi (1.15.6-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 09 Sep 2022 07:36:42 +0200

coq-elpi (1.15.5-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to turn a warning-error to just a warning.
  * Add patch to fix the install target.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 22 Aug 2022 18:07:48 +0200

=== debian/control ===
Source: coq-elpi
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-ocaml, dh-coq, coq, libcoq-ocaml-dev (>= 8.15),
               libcoq-stdlib, libelpi-ocaml-dev
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
Homepage: https://github.com/LPCIC/coq-elpi

Package: libcoq-elpi
Architecture: any
Depends: ${misc:Depends}, ${coq:Depends}, libelpi-ocaml-dev
Provides: ${coq:Provides}
Description: Coq plugin embedding Elpi
 This package makes it possible to define new commands and tactics
 for Coq in Elpi.
 .
 Elpi implements a lambda-Prolog interpreter enriched with
 constraint handling rules.
 .
 Coq is a proof assistant for higher-order logic.

## coq-elpi 1.16.0

=== Makefile ===
--- 
+++ 
@@ -106,7 +106,7 @@
 src/coq_elpi_config.ml:
 	echo "let elpi_dir = \"$(abspath $(ELPIDIR))\";;" > $@
 
-clean:
+clean: Makefile.coq Makefile.test.coq
 	@$(MAKE) -f Makefile.coq $@
 	@$(MAKE) -f Makefile.test.coq $@
 	@$(foreach app,$(APPS),$(MAKE) -C $(app) $@ &&) true

=== apps/NES/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 Makefile.test.coq Makefile.test.coq.conf: _CoqProject.test
 	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq
 
-clean:
+clean: Makefile.coq Makefile.test.coq
 	@$(MAKE) -f Makefile.coq $@
 	@$(MAKE) -f Makefile.test.coq $@

=== debian/changelog ===
coq-elpi (1.16.0-2) unstable; urgency=medium

  * Change b-dep from libcoq-ocaml-dev to libcoq-core-ocaml-dev.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 25 Jan 2023 07:46:31 +0100

coq-elpi (1.16.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 19 Nov 2022 18:31:24 +0100

coq-elpi (1.15.6-4) unstable; urgency=medium

  * Provide a better fix for the libelpi-ocaml depend.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 13 Nov 2022 21:47:42 +0100

coq-elpi (1.15.6-3) unstable; urgency=medium

  * Make explicit we need a newer elpi.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 12 Nov 2022 17:52:18 +0100

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,20 @@
 Priority: optional
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13),
-               dh-ocaml, dh-coq, coq, libcoq-ocaml-dev (>= 8.15),
-               libcoq-stdlib, libelpi-ocaml-dev
+Build-Depends: coq,
+               debhelper-compat (= 13),
+               dh-coq,
+               dh-ocaml,
+               libcoq-core-ocaml-dev (>= 8.15),
+               libcoq-stdlib,
+               libelpi-ocaml-dev
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
 Homepage: https://github.com/LPCIC/coq-elpi
 
 Package: libcoq-elpi
 Architecture: any
-Depends: ${misc:Depends}, ${coq:Depends}, libelpi-ocaml-dev
+Depends: libelpi-ocaml-dev, ${coq:Depends}, ${misc:Depends}, ${ocaml:Depends}
 Provides: ${coq:Provides}
 Description: Coq plugin embedding Elpi
  This package makes it possible to define new commands and tactics

## coq-elpi 1.17.1

=== Makefile ===
--- 
+++ 
@@ -99,6 +99,7 @@
 	@$(COQBIN)/coq_makefile -f _CoqProject.examples -o Makefile.examples.coq
 src/coq_elpi_builtins_HOAS.ml: elpi/coq-HOAS.elpi Makefile.coq.local
 	echo "(* Automatically generated from $<, don't edit *)" > $@
+	echo "(* Regenerate via 'make $@' *)" >> $@
 	echo "let code = {|" >> $@
 	cat $< >> $@
 	echo "|}" >> $@

=== debian/changelog ===
coq-elpi (1.17.1-1build9) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 04 Nov 2023 20:13:21 +0100

coq-elpi (1.17.1-1build8) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Aug 2023 17:11:13 +0200

coq-elpi (1.17.1-1build7) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Aug 2023 09:33:50 +0200

coq-elpi (1.17.1-1build6) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jul 2023 05:34:55 +0200

coq-elpi (1.17.1-1build5) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jul 2023 11:44:49 +0200

coq-elpi (1.17.1-1build4) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Jul 2023 07:14:07 +0200

coq-elpi (1.17.1-1build3) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Jul 2023 19:14:18 +0200

coq-elpi (1.17.1-1build2) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Jul 2023 08:17:02 +0200

coq-elpi (1.17.1-1build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Jul 2023 22:40:40 +0200

coq-elpi (1.17.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.6.2.
  * Add lintian overrides for false positives.
  * Bump Coq version depend.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Jun 2023 19:29:08 +0200

## coq-elpi 1.19.3

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 DEPS=$(ELPIDIR)/elpi.cmxa $(ELPIDIR)/elpi.cma
 
-APPS=$(addprefix apps/, derive eltac NES locker)
+APPS=$(addprefix apps/, derive eltac NES locker coercion)
 
 ifeq "$(COQ_ELPI_ALREADY_INSTALLED)" ""
 DOCDEP=build
@@ -83,6 +83,7 @@
 			-R theories elpi -Q src elpi \
 			$(tut) &&) true
 	@cp stlc.html doc/
+	@cp etc/tracer.png doc/
 
 .merlin: force
 	@rm -f .merlin

=== apps/derive/Makefile ===
# detection of coq
ifeq "$(COQBIN)" ""
COQBIN := $(shell which coqc >/dev/null 2>&1 && dirname `which coqc`)
endif
ifeq "$(COQBIN)" ""
$(error Coq not found, make sure it is installed in your PATH or set COQBIN)
else
$(info Using coq found in $(COQBIN), from COQBIN or PATH)
endif
export COQBIN := $(COQBIN)/

all: build test

build: Makefile.coq
	@$(MAKE) --no-print-directory -f Makefile.coq

test: Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq

coverage:
	@$(MAKE) --no-print-directory -f Makefile.coq coverage

theories/%.vo: force
	@$(MAKE) --no-print-directory -f Makefile.coq $@
tests/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@
examples/%.vo: force build Makefile.test.coq
	@$(MAKE) --no-print-directory -f Makefile.test.coq $@

Makefile.coq Makefile.coq.conf: _CoqProject
	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
Makefile.test.coq Makefile.test.coq.conf: _CoqProject.test
	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq

clean: Makefile.coq Makefile.test.coq
	@$(MAKE) -f Makefile.coq $@
	@$(MAKE) -f Makefile.test.coq $@

.PHONY: force all build test

install:
	@$(MAKE) -f Makefile.coq $@

=== debian/changelog ===
coq-elpi (1.19.3-2build4) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Apr 2024 09:13:55 +0200

coq-elpi (1.19.3-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:53:25 +0000

coq-elpi (1.19.3-2build2) noble; urgency=medium

  * No-change rebuild for new libcoq-stdlib ABI

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Mar 2024 00:12:59 +0000

coq-elpi (1.19.3-2build1) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:24:20 +0100

coq-elpi (1.19.3-2) unstable; urgency=medium

  * Team upload
  * Increase timeout in test that takes a bit longer on riscv64

 -- Stéphane Glondu <glondu@debian.org>  Wed, 03 Jan 2024 08:51:24 +0100

coq-elpi (1.19.3-1) unstable; urgency=medium

  * Fix d/rules clean target (Closes: #1044251).
  * New upstream release.
  * Drop all patches.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 21 Dec 2023 15:23:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: coq-elpi
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends: coq,
                debhelper-compat (= 13),
                dh-coq,
                dh-ocaml,
-               libcoq-core-ocaml-dev (>= 8.15),
+               libcoq-core-ocaml-dev (>= 8.17),
                libcoq-stdlib,
                libelpi-ocaml-dev
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi

## coq-elpi 2.1.0

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
 
 DEPS=$(ELPIDIR)/elpi.cmxa $(ELPIDIR)/elpi.cma
 
-APPS=$(addprefix apps/, derive eltac NES locker coercion)
+APPS=$(addprefix apps/, derive eltac NES locker coercion cs tc)
 
 ifeq "$(COQ_ELPI_ALREADY_INSTALLED)" ""
 DOCDEP=build
@@ -91,13 +91,19 @@
 
 .PHONY: force build all test doc
 
-Makefile.coq Makefile.coq.conf: src/coq_elpi_builtins_HOAS.ml src/coq_elpi_config.ml _CoqProject
+Makefile.coq Makefile.coq.conf: src/coq_elpi_builtins_HOAS.ml src/coq_elpi_builtins_arg_HOAS.ml src/coq_elpi_config.ml _CoqProject
 	@$(COQBIN)/coq_makefile -f _CoqProject -o Makefile.coq
 	@$(MAKE) --no-print-directory -f Makefile.coq .merlin
 Makefile.test.coq Makefile.test.coq.conf: _CoqProject.test
 	@$(COQBIN)/coq_makefile -f _CoqProject.test -o Makefile.test.coq
 Makefile.examples.coq Makefile.examples.coq.conf: _CoqProject.examples
 	@$(COQBIN)/coq_makefile -f _CoqProject.examples -o Makefile.examples.coq
+src/coq_elpi_builtins_arg_HOAS.ml: elpi/coq-arg-HOAS.elpi Makefile.coq.local
+	echo "(* Automatically generated from $<, don't edit *)" > $@
+	echo "(* Regenerate via 'make $@' *)" >> $@
+	echo "let code = {|" >> $@
+	cat $< >> $@
+	echo "|}" >> $@
 src/coq_elpi_builtins_HOAS.ml: elpi/coq-HOAS.elpi Makefile.coq.local
 	echo "(* Automatically generated from $<, don't edit *)" > $@
 	echo "(* Regenerate via 'make $@' *)" >> $@
@@ -145,3 +151,6 @@
 apps/%.vo: force
 	@$(MAKE) -C apps/$(word 1,$(subst /, ,$*)) \
 		$(subst $(SPACE),/,$(wordlist 2,99,$(subst /, ,$*))).vo
+
+nix:
+	nix-shell --arg do-nothing true --run "updateNixToolBox & genNixActions"

=== debian/changelog ===
coq-elpi (2.1.0-1build5) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:51:38 +0200

coq-elpi (2.1.0-1build4) oracular; urgency=medium

  * Rebuild against latest coq

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 04 Aug 2024 11:14:58 -0400

coq-elpi (2.1.0-1build3) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 15 Jun 2024 16:33:52 +0200

coq-elpi (2.1.0-1build2) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 03 Jun 2024 23:41:03 +0200

coq-elpi (2.1.0-1build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 May 2024 22:09:14 +0200

coq-elpi (2.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 30 Mar 2024 09:35:03 +0100

coq-elpi (2.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 24 Feb 2024 09:56:02 +0100

coq-elpi (2.0.0-1) unstable; urgency=medium

  * Better document the riscv64 patch (and forward it upstream).
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 25 Jan 2024 06:32:39 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin
export ELPIDIR := $(OCAML_STDLIB_DIR)/elpi

%:
	dh $@ --with ocaml,coq

override_dh_auto_build:
	$(MAKE) build OCAMLWARN=

override_dh_auto_clean:
	$(MAKE) clean
	rm -f src/coq_elpi_builtins_HOAS.ml src/coq_elpi_config.ml
	rm -f tests/test_glob/coqdoc.css
	find . -name "*.aux" -delete
	find . -name "*.html" -delete
	find . -name "*.txt" -delete
	find . -name .merlin -delete
	find . -name "Makefile*conf" -delete
	find . -name "Makefile*coq" -delete

override_dh_ocaml:
	dh_ocaml --nodefined-map=libcoq-elpi-ocaml-dev:Elpi_parser,Elpi_util,Elpi_parser__Ast,Elpi__Runtime,Elpi__,Elpi_util__Util,Elpi__Builtin_checker,Elpi__Builtin,Elpi__Ptmap,Elpi_parser__Grammar,Elpi__Data,Elpi_lexer_config,Elpi__API,Elpi_parser__Parse,Elpi__Builtin_set,Trace_ppx_runtime,Elpi_parser__Parser_config,Elpi_parser__Error_messages,Elpi_parser__Lexer,Elpi,Elpi_exer_config__Tokens,Elpi_Builtin_stdlib,Elpi__Legacy_parser_proxy,Elpi__Builtin_map,Elpi_lexer_config__Tokens,Elpi__Compiler,Trace_ppx_runtime__Runtime,Elpi_lexer_config__Lexer_config,Elpi__Builtin_stdlib,Elpi__Runtime_trace_off,MenhirLib,Ppx_deriving_runtime,Re__Perl,Re__Core,Re__Pcre,Re_str,Re__Automata,Re__Emacs,Re,Re__Fmt,Re__Group,Re__,Re__Glob,Re__Pmark,Re__Category,Re__Str,Re__Posix,Re__Color_map,Re__Cset,Result

## coq-elpi 2.2.3

=== Makefile ===
dune = dune $(1) $(DUNE_$(1)_FLAGS)

all:
	$(call dune,build)
.PHONY: all

build-core:
	$(call dune,build) theories
.PHONY: build-core

build-apps:
	$(call dune,build) $$(find apps -type d -name theories)
.PHONY: build-apps

build:
	$(call dune,build) -p coq-elpi @install
.PHONY: build

test-core:
	$(call dune,runtest) tests
.PHONY: test-core

test-apps:
	$(call dune,build) $$(find apps -type d -name tests)
.PHONY: test-apps

test:
	$(call dune,runtest)
	$(call dune,build) $$(find apps -type d -name tests)
.PHONY: test

examples:
	$(call dune,build) examples
.PHONY: examples

doc: build
	@echo "########################## generating doc ##########################"
	@mkdir -p doc
	@$(foreach tut,$(wildcard examples/tutorial*$(ONLY)*.v),\
		echo ALECTRYON $(tut) && OCAMLPATH=$(shell pwd)/_build/install/default/lib ./etc/alectryon_elpi.py \
		    --frontend coq+rst \
			--output-directory doc \
		    --pygments-style vs \
			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi_elpi elpi_elpi \
			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi elpi \
			$(tut) &&) true
	@cp stlc.html doc/
	@cp etc/tracer.png doc/

clean:
	$(call dune,clean)
.PHONY: clean

install:
	$(call dune,install) coq-elpi
.PHONY: install

nix:
	nix-shell --arg do-nothing true --run "updateNixToolBox && genNixActions"
.PHONY: nix

=== debian/changelog ===
coq-elpi (2.2.3-1build1) plucky; urgency=medium

  * Rebuild against latest coq

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 20 Nov 2024 21:31:05 -0500

coq-elpi (2.2.3-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 20 Nov 2024 10:43:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: coq-elpi
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
@@ -12,7 +11,9 @@
                dh-ocaml,
                libcoq-core-ocaml-dev (>= 8.17),
                libcoq-stdlib,
-               libelpi-ocaml-dev
+               libelpi-ocaml-dev,
+               libppx-optcomp-ocaml-dev,
+               ocaml-dune
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq-elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq-elpi.git
 Homepage: https://github.com/LPCIC/coq-elpi

## coq-elpi 2.3.0

=== Makefile ===
--- 
+++ 
@@ -2,10 +2,12 @@
 
 all:
 	$(call dune,build)
+	$(call dune,build) builtin-doc
 .PHONY: all
 
 build-core:
 	$(call dune,build) theories
+	$(call dune,build) builtin-doc
 .PHONY: build-core
 
 build-apps:
@@ -14,10 +16,12 @@
 
 build:
 	$(call dune,build) -p coq-elpi @install
+	$(call dune,build) builtin-doc
 .PHONY: build
 
 test-core:
 	$(call dune,runtest) tests
+	$(call dune,build) tests
 .PHONY: test-core
 
 test-apps:
@@ -26,6 +30,7 @@
 
 test:
 	$(call dune,runtest)
+	$(call dune,build) tests
 	$(call dune,build) $$(find apps -type d -name tests)
 .PHONY: test
 
@@ -44,7 +49,7 @@
 			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi_elpi elpi_elpi \
 			-R $(shell pwd)/_build/install/default/lib/coq/user-contrib/elpi elpi \
 			$(tut) &&) true
-	@cp stlc.html doc/
+	@cp ./_build/default/examples/stlc.txt doc/
 	@cp etc/tracer.png doc/
 
 clean:

=== debian/changelog ===
coq-elpi (2.3.0-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:27:16 +0100

coq-elpi (2.3.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.7.0.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 18 Dec 2024 12:09:37 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/coq/coqvars.mk

export COQTOP := $(COQ_STDLIB_DIR)
export COQLIB := $(COQ_STDLIB_DIR)
export COQBIN := /usr/bin
export ELPIDIR := $(OCAML_STDLIB_DIR)/elpi

%:
	dh $@ --with ocaml,coq

override_dh_auto_build:
	dune build -p coq-elpi

override_dh_auto_clean:
	dune clean


override_dh_auto_install:
	dune install coq-elpi --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=$(OCAML_STDLIB_DIR)
	rm -fr $(CURDIR)/debian/tmp/usr/doc/coq-elpi

override_dh_ocaml:
	dh_ocaml --nodefined-map=libcoq-elpi-ocaml-dev:Elpi_parser,Elpi_util,Elpi_parser__Ast,Elpi__Runtime,Elpi__,Elpi_util__Util,Elpi__Builtin_checker,Elpi__Builtin,Elpi__Ptmap,Elpi_parser__Grammar,Elpi__Data,Elpi_lexer_config,Elpi__API,Elpi_parser__Parse,Elpi__Builtin_set,Trace_ppx_runtime,Elpi_parser__Parser_config,Elpi_parser__Error_messages,Elpi_parser__Lexer,Elpi,Elpi_exer_config__Tokens,Elpi_Builtin_stdlib,Elpi__Legacy_parser_proxy,Elpi__Builtin_map,Elpi_lexer_config__Tokens,Elpi__Compiler,Trace_ppx_runtime__Runtime,Elpi_lexer_config__Lexer_config,Elpi__Builtin_stdlib,Elpi__Runtime_trace_off,MenhirLib,Ppx_deriving_runtime,Re__Perl,Re__Core,Re__Pcre,Re_str,Re__Automata,Re__Emacs,Re,Re__Fmt,Re__Group,Re__,Re__Glob,Re__Pmark,Re__Category,Re__Str,Re__Posix,Re__Color_map,Re__Cset,Result

## coq-elpi 2.4.0

=== Makefile ===
--- 
+++ 
@@ -1,40 +1,50 @@
 dune = dune $(1) $(DUNE_$(1)_FLAGS)
 
-all:
+elpi/dune: elpi/dune.in
+	@rm -f $@
+	@echo "; generated by make, do not edit" > $@
+	@if $$(coqc --version | grep -q "8.19\|8.20") ; then \
+	  sed -e 's/@@STDLIB_THEORY@@//' $< >> $@ ; \
+	else \
+	  sed -e 's/@@STDLIB_THEORY@@/(theories Stdlib)/' $< >> $@ ; \
+	fi
+	@chmod a-w $@
+
+all: elpi/dune
 	$(call dune,build)
 	$(call dune,build) builtin-doc
 .PHONY: all
 
-build-core:
+build-core: elpi/dune
 	$(call dune,build) theories
 	$(call dune,build) builtin-doc
 .PHONY: build-core
 
-build-apps:
+build-apps: elpi/dune
 	$(call dune,build) $$(find apps -type d -name theories)
 .PHONY: build-apps
 
-build:
+build: elpi/dune
 	$(call dune,build) -p coq-elpi @install
 	$(call dune,build) builtin-doc
 .PHONY: build
 
-test-core:
+test-core: elpi/dune
 	$(call dune,runtest) tests
 	$(call dune,build) tests
 .PHONY: test-core
 
-test-apps:
+test-apps: elpi/dune
 	$(call dune,build) $$(find apps -type d -name tests)
 .PHONY: test-apps
 
-test:
+test: elpi/dune
 	$(call dune,runtest)
 	$(call dune,build) tests
 	$(call dune,build) $$(find apps -type d -name tests)
 .PHONY: test
 
-examples:
+examples: elpi/dune
 	$(call dune,build) examples
 .PHONY: examples
 
@@ -56,7 +66,7 @@
 	$(call dune,clean)
 .PHONY: clean
 
-install:
+install: elpi/dune
 	$(call dune,install) coq-elpi
 .PHONY: install

=== debian/changelog ===
coq-elpi (2.4.0-1build1) plucky; urgency=medium

  * No-change rebuild for coq ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2025 21:04:34 +0100

coq-elpi (2.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 15 Feb 2025 15:21:18 +0100

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,7 @@
 	dh $@ --with ocaml,coq
 
 override_dh_auto_build:
+	make elpi/dune
 	dune build -p coq-elpi
 
 override_dh_auto_clean:
